/****************************************************************************\
 Copyright 1998, 1999 Endor Productions Inc.. All rights reserved.
 Written and compiled by Nawfel 'Topaz' Tricha. 
 Source code to LifeScript compiler, OpenGL Model Viewer, Scene editor, and 
 .WAL texture sound linker. 
 This code is open source. It is available to everybody for educational 
 purposes only. Legal actions will be taken against any financial exploitation 
 of this material.
 Enjoy,
 
   -Nawfel 'Topaz' Tricha
\****************************************************************************/

#if !defined(AFX_LIFEDOC_H__79D3612A_663D_11D2_86B4_444553540000__INCLUDED_)
#define AFX_LIFEDOC_H__79D3612A_663D_11D2_86B4_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "bnf.h"

class CLifeDoc : public CDocument
{
protected: // create from serialization only
	CLifeDoc();
	DECLARE_DYNCREATE(CLifeDoc)

// Attributes
public:
   float version;
   char *dline[50];
   char commandline[256];
	int commandindex;
   short m_display;
   short debug;
   short x_pos, 
         y_pos,
         ly,
         lx,
         prompt,
         commandlist;
   COLORREF console_background,
            console_foreground;
   LOGFONT logfont;   
   HWND windoe;
   short max_lines,
         max_chars;
	char PathName[256];
	char *FrameSound[512];

	env_t	env;
	bnf_t bnf[200];		
	field_tag_t field_tag[48];
	class_string_tag_t class_string_tag[48];
	class_tag_t class_tag[48];
	level_string_tag_t level_string_tag[48];
	level_tag_t level_tag[48];
	team_tag_t team_tag[48];
	operator_tag_t operator_tag[16];
	check_tag_t check_tag[16];
	script_t	script;
	history_t history[200];
	on_uses_t on_uses[100];

   int labels, current_instruction, intercepts;

   char FileIn[256], FileOut[256];
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLifeDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CLifeDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CLifeDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void setbnf();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LIFEDOC_H__79D3612A_663D_11D2_86B4_444553540000__INCLUDED_)
