/****************************************************************************\
 Copyright 1998, 1999 Endor Productions Inc.. All rights reserved.
 Written and compiled by Nawfel 'Topaz' Tricha. 
 Source code to LifeScript compiler, OpenGL Model Viewer, Scene editor, and 
 .WAL texture sound linker. 
 This code is open source. It is available to everybody for educational 
 purposes only. Legal actions will be taken against any financial exploitation 
 of this material.
 Enjoy,
 
   -Nawfel 'Topaz' Tricha
\****************************************************************************/

#if !defined(AFX_SCENE_H__FB9456C0_015F_11D3_A9D8_444553540000__INCLUDED_)
#define AFX_SCENE_H__FB9456C0_015F_11D3_A9D8_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// Scene.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// Scene dialog

class Scene : public CDialog
{
	int list_index, list_size, *index;

public:
	CLifeDoc* pDoc;
   CMainFrame *pMainWnd;
	CLifeView* pView;

// Construction
public:
	Scene(CWnd* pParent = NULL);   // standard constructor


// Dialog Data
	//{{AFX_DATA(Scene)
	enum { IDD = IDD_SCENE };
	CSliderCtrl	m_gamma;
	CButton	m_realtime;
	CListCtrl	m_list;
	CSpinButtonCtrl	m_interpolation;
	CSpinButtonCtrl	m_framedelay;
	CButton	m_interpolations;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(Scene)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(Scene)
	afx_msg void OnLoopstart();
	afx_msg void OnSound();
	afx_msg void OnStart();
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnEnd();
	afx_msg void OnSave();
	afx_msg void OnReset();
	afx_msg void OnLoad();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	void UpdateList();
	int  GetCurrentFrame();		
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCENE_H__FB9456C0_015F_11D3_A9D8_444553540000__INCLUDED_)
