/****************************************************************************\
 Copyright 1998, 1999 Endor Productions Inc.. All rights reserved.
 Written and compiled by Nawfel 'Topaz' Tricha. 
 Source code to LifeScript compiler, OpenGL Model Viewer, Scene editor, and 
 .WAL texture sound linker. 
 This code is open source. It is available to everybody for educational 
 purposes only. Legal actions will be taken against any financial exploitation 
 of this material.
 Enjoy,
 
   -Nawfel 'Topaz' Tricha
\****************************************************************************/

#if !defined(AFX_WALLER_H__FE99AB00_FD8F_11D2_A9D8_444553540000__INCLUDED_)
#define AFX_WALLER_H__FE99AB00_FD8F_11D2_A9D8_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// Waller.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// Waller dialog

#define TEXTURE_DIRT		1024
#define TEXTURE_METAL	2048
#define TEXTURE_TILES	4096
#define TEXTURE_WOOD		8192

#define MIPLEVELS 4


typedef struct
{
char name[32];
unsigned width, height;
unsigned offsets[MIPLEVELS]; // four mip maps stored
char animname[32]; // next frame in animation chain
int flags;
int contents;
int value;
} miptex_t;

typedef struct 
{
	char name[32];
	char path[256];
	int  flags;
} wal_file;

typedef struct 
{
	int flags;
} wal_header;

class Waller : public CDialog
{
// Construction
public:
	Waller(CWnd* pParent = NULL);   // standard constructor
   CLifeDoc* pDoc;
   CMainFrame *pMainWnd;

// Dialog Data
	//{{AFX_DATA(Waller)
	enum { IDD = IDD_WALLER };
	CListCtrl	m_list;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(Waller)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

private:
	int list_size;
	int list_index;
	wal_file *wal_index;
	int *index;

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(Waller)
	afx_msg void OnConcrete();
	afx_msg void OnDirt();
	afx_msg void OnLoad();
	afx_msg void OnMetal();
	afx_msg void OnRestore();
	afx_msg void OnSave();
	afx_msg void OnTiles();
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WALLER_H__FE99AB00_FD8F_11D2_A9D8_444553540000__INCLUDED_)
